# -*- coding: UTF-8 -*-
#
# Copyright (C) 2007 by Jan Dittberner.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.
#
# Version: $Id$

from sqlalchemy import *
from gnuviechadmin.exceptions import *
from BackendEntity import *

class BackendEntityHandler(object):
    def __init__(self, entityclass, verbose = False):
        self.entityclass = entityclass
        self.verbose = verbose

    def create(self, **kwargs):
#        try:
            sess = create_session()
            entity = self.entityclass(self.verbose, **kwargs)
            try:
                entity.create_hook()
                sess.save(entity)
                sess.flush()
            except:
                sess.delete(entity)
                sess.flush()
                raise
#        except Exception, e:
#            raise CreationFailedError(self.entityclass.__name__, e)

    def fetchall(self):
        """Fetches all entities of the managed entity type."""
        session = create_session()
        query = session.query(self.entityclass)
        allentities = query.select()
        for entity in allentities:
            BackendEntity.__init__(entity, self.verbose)
        return allentities

    def delete(self, pkvalue):
        """Deletes the entity of the managed entity type that has the
        specified primary key value."""
        try:
            sess = create_session()
            entity = sess.query(self.entityclass).get(pkvalue)
            if entity:
                BackendEntity.__init__(entity, self.verbose)
                if self.verbose:
                    print "delete %s" % (str(entity))
                entity.delete_hook()
                sess.delete(entity)
            sess.flush()
        except Exception, e:
            raise DeleteFailedError(self.entityclass.__name__, e)
