# -*- coding: UTF-8 -*-
#
# Copyright (C) 2007 by Jan Dittberner.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.
#
# Version: $Id$

from sqlalchemy import *
from tables import record_table
from gnuviechadmin.exceptions import *

from BackendEntity import *
from BackendEntityHandler import *

class Record(object):
    """Entity class for DNS domain records."""
    def __init__(self, **kwargs):
        for (key, value) in kwargs.items():
            self.__setattr__(key, value)

    #_shortkeys = ("recordid", "domainid", "name", "type", "content")

    #def __init__(self, verbose = False, **kwargs):
    #    BackendEntity.__init__(self, verbose)
    #    self.recordid = None
    #    self.domainid = None
    #    self.name = None
    #    self.type = None
    #    self.content = None
    #    self.ttl = None
    #    self.prio = None
    #    self.change_date = None
    #    self.validate()

record_mapper = mapper(Record, record_table)

class RecordHandler(BackendEntityHandler):
    """BackendEntityHandler for Record entities."""

    def __init__(self, verbose = False):
        BackendEntityHandler.__init__(self, Record, verbose)
